/// $Id: sslbuffer.C,v 1.2 2001/06/09 12:16:25 dvermeir Exp $
#include	"sslbuffer.h"
#include	<iostream>
#include	<openssl/ssl.h>
#include	<openssl/err.h>
#include	<dvutil/ntostr.h>

namespace Dv {
namespace Ssl {

SslBuffer::SslBuffer(SslContext& context,int fd,
                     size_t inbufsize, size_t outbufsize, int msecs):
	fdstreambuf(fd,inbufsize,outbufsize,msecs), 
	ssl_(SSL_new(static_cast<SSL_CTX*>(context.context()))) {
SSL_set_verify(static_cast<SSL*>(ssl_),SSL_VERIFY_NONE,0);
SSL_set_fd(static_cast<SSL*>(ssl_),fd);
}

SslBuffer::~SslBuffer() {
SSL_free(static_cast<SSL*>(ssl_));
}

int
SslBuffer::rread(char* buf, size_t len) {
return SSL_read(static_cast<SSL*>(ssl_), buf, len);
}

int
SslBuffer::rwrite(char* buf, size_t len) {
return SSL_write(static_cast<SSL*>(ssl_), buf, len);
}

const char*
SslBuffer::cipher() const {
return SSL_get_cipher(static_cast<SSL*>(ssl_));
}


}}
