// $Id: sslserversocket.C,v 1.4 2002/10/19 10:36:49 dvermeir Exp $
#include <openssl/ssl.h>
#include <openssl/err.h>

#include "sslserversocket.h"
#include "sslstrerror.h"

using namespace std;

namespace Dv {
namespace Ssl {

SslServerSocket::SslServerSocket(SslContext& context, int port, int backlog)
  throw (runtime_error): ServerSocket(port,backlog), context_(context) {
if ((context.rsa_private_key_file()==0) ||
    (context.certificate_file()==0))
  throw runtime_error("SslServerSocket:: need context with key and cert files");
// SSL_CTX_set_verify(SSL_VERIFY_PEER)
// SSL_VERIFY_NONE server will not request client certificate
// SSL_VERIFY_PEER server will request client certificate

/*
void SSL_set_verify(SSL *s, int mode,
                                  int (*verify_callback)(int,
				  X509_STORE_CTX *));
*/
}

ref<SslSocket>
SslServerSocket::accept(time_t delay, size_t bufsz) {
int fd(fd_accept());
ref<SslSocket>	so(SslSocket::fd2sslsocket(context_,fd,bufsz,delay));
if (*so) {
  // The following line is useless.
  SSL_set_accept_state(static_cast<SSL*>(so->ssl()));
  int n(SSL_accept (static_cast < SSL * >(so->ssl ())));
  if (n!=1)
    so->error(SslSocket::SSL_ACCEPT_FAILED);
  }
return so;
}

}}
