// $Id: sslsocket.C,v 1.6 2002/10/19 10:36:49 dvermeir Exp $
#include <openssl/ssl.h>

#include "sslsocket.h"
#include "sslstrerror.h"

using namespace std;

namespace Dv {
namespace Ssl {

SslSocket::SslSocket(SslContext& ctxt,const string& host,int port,
		     size_t bfsz,int msecs):
  Socket(host,port, sslbuf_ = new SslBuffer(ctxt,Socket::mkfd(),bfsz,bfsz,msecs)),
  context_(ctxt) {
// sslbuf_->debug(&cerr);
// The following line is useless.
SSL_set_connect_state(static_cast<SSL*>(sslbuf_->ssl()));
int n(SSL_connect(static_cast<SSL*>(sslbuf_->ssl())));
if (n!=1)
  error(SSL_CONNECTION_FAILED);
}

// The following is for use by fd2sslsocket.
SslSocket::SslSocket(SslContext& ctxt,int fd, size_t bsz,int msecs):
  Socket(sslbuf_ = new SslBuffer(ctxt,fd,bsz,bsz,msecs)),
  context_(ctxt) {
}

SslSocket::~SslSocket() {
}

ref<SslSocket>
SslSocket::fd2sslsocket(SslContext& context,int fd,size_t bufsize,int msecs) {
return ref<SslSocket>(new SslSocket(context,fd,bufsize,msecs));
}

const char*
SslSocket::cipher() const {
return (sslbuf_?sslbuf_->cipher():"");
}

void*
SslSocket::ssl() const {
return sslbuf_->ssl(); 
}

string
SslSocket::strerror() const {
switch (error()) {
  case SSL_CONNECTION_FAILED: return "Ssl connection failed";
  case SSL_ACCEPT_FAILED: return "Ssl accept failed";
  default: return Socket::strerror();
  }
}
}}
