// $Id: x509cert.C,v 1.4 2003/06/22 12:18:45 dvermeir Exp $

#include <config.h>
#include <openssl/ssl.h>

#include "x509cert.h"

using namespace std;

namespace Dv {
namespace Ssl {

X509Certificate::X509Certificate(const SslSocket& so) throw (runtime_error): 
  name_(), issuer_() {
const string ERR("X509Certificate::X509Certificate(): ");

X509* cert = SSL_get_peer_certificate(static_cast<SSL*>(so.ssl()));
if (cert==0)
  throw runtime_error(ERR + "SSL_get_peer_certificate failed");

{
#ifdef HAVE_X509_NAME
X509_NAME* x509_name = X509_get_subject_name(cert);
// Apparently, result of X509_get_subject_name should not be released.
char* nm = X509_NAME_oneline(x509_name,0,0);
name_	= string(nm);
::free(nm);
#else
char*	nm = X509_NAME_oneline(X509_get_subject_name(cert),NULL,0);
name_	= string(nm);
free(nm);
#endif
}

{
#ifdef HAVE_X509_NAME
X509_NAME* x509_name = X509_get_issuer_name(cert);
// Apparently, result of X509_get_issuer_name should not be released.
char* nm = X509_NAME_oneline(x509_name,0,0);
issuer_	= string(nm);
::free(nm);
#else
char* nm = X509_NAME_oneline(X509_get_issuer_name(cert),NULL,0);
issuer_	= string(nm);
::free(nm);
#endif
}
X509_free(cert);
}

}}
