#ifndef  X509CERT_H
#define  X509CERT_H

// $Id: x509cert.h,v 1.6 2003/06/22 12:18:45 dvermeir Exp $

/* @file This file declares the class Dv::Ssl::X509Certificate for use
  with Dv::Ssl::SslSocket.
*/

#include  <stdexcept>
#include  <dvssl/sslsocket.h>

namespace Dv {
namespace Ssl {

/** Represents a X509 certificate. */
class X509Certificate {
public:
  /** Constructor.  The server certificate is retrieved from the client socket. 
   * @param so open SslSocket
   * @exception std::runtime_error if no certificate obtained.
   */
  X509Certificate(const SslSocket& so) throw (std::runtime_error);
  /** Destructor. */
  ~X509Certificate() {}

  /** Name appearing in certificate. */
  const std::string&	name() const { return name_; }
  /** Issuer appearing in certificate. */
  const std::string&	issuer() const { return issuer_; }
private:
  std::string	name_;
  std::string	issuer_;
};

}}
#endif

